<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.IGadgetRepoService" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Comment" %>
<%@ page import="org.apache.axiom.om.util.Base64" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="org.wso2.carbon.dashboard.common.DashboardConstants"%>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%--
 * Copyright 2006-2009 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
--%>
<%
    response.setHeader("Cache-Control","no-cache");
    response.setHeader("Pragma","no-cache");
    response.setDateHeader ("Expires", -1);

    String loggeduser = (String) request.getSession().getAttribute("logged-user");

    if ((request.getSession().getAttribute("logged-user") == null)) {
        // We need to log in this user
       CarbonUIMessage.sendCarbonUIMessage("Timed out", CarbonUIMessage.ERROR, request);
        %>
            <script type="text/javascript">
                CARBON.showErrorDialog(jsi18n["time.out"], null, null);
            </script>
        <%
       return;
    }

    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
            CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    IGadgetRepoService gadgetRepoServiceClient = (IGadgetRepoService) CarbonUIUtil
            .getServerProxy(new GadgetRepoServiceClient(cookie,
                                                        backendServerURL, configContext, request
                    .getLocale()), IGadgetRepoService.class,
                                   session);

    String gadgetPath = request.getParameter("gadgetPath");

    String userRating = gadgetRepoServiceClient.getUserRating(gadgetPath, loggeduser);

    Gadget gadget = null;

    if (gadgetPath != null) {
        gadget = gadgetRepoServiceClient.getGadget(gadgetPath);
    }

    String activeTab = request.getParameter("tab");
    if (activeTab == null) {
        activeTab = "0";
    }
    
	String pageNumComStr = request.getParameter("pageNumCom");
	
	int pages = 0;
	Integer commentCount = gadgetRepoServiceClient.getCommentsCount(gadgetPath);
	if(commentCount != null ){
	    pages = (commentCount / DashboardConstants.COMMENTS_PER_PAGE);
	    if((commentCount % DashboardConstants.COMMENTS_PER_PAGE) != 0){
	    	pages++;
	    }
	}
	
	
	int pageNumCom = Integer.parseInt(pageNumComStr);
	int start = 0;
	
	if(pageNumCom != 0){
	 	start = pageNumCom * DashboardConstants.COMMENTS_PER_PAGE;
	}
	
	int end = start + DashboardConstants.COMMENTS_PER_PAGE;

	Comment[] comments = gadgetRepoServiceClient.getCommentSet(gadgetPath, start, DashboardConstants.COMMENTS_PER_PAGE);

    SimpleDateFormat formatter = new SimpleDateFormat("MMM-dd-yyyy");
%>
<HEAD>
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</HEAD>
<table class="gadgetComments" id="commentsArea">
    <thead>
        <tr>
            <th>Comments (<%if (commentCount != null){out.print(commentCount);}%>)</th>
        </tr>
        <tbody>

            <%
                if ((comments != null) && (comments.length > 0)) {
                    for (int i = 0; i < comments.length; i++) {
                        Comment tempCom = comments[i];
                        if (tempCom != null) {
            %>
            <input class="commentCls" type="hidden" id="comment-<%=i%>" value="<%=tempCom.getCommentPath()%>"/>
            <%if ((i % 2) > 0) { %>
            <tr class="tableOddRow">
                <td><%
                    if ((gadgetRepoServiceClient.isAdmin(loggeduser)) ||
                            (loggeduser.equals(tempCom.getAuthorUserName()))) {
                %>
                    <div class="delete"><a onclick="deleteComment(<%=i%>)"><img width="16"
                                                                                height="16"
                                                                                src="images/gadget-close.gif"
                                                                                border="0"/></a>
                    </div>
                    <%} %>
                    <strong><%=tempCom.getAuthorUserName()%>,</strong> <%=formatter.format(tempCom.getCreateTime())%>
                    <br/>
                    <%=tempCom.getCommentText()%>
                </td>
            </tr>
            <%} else {%>
            <tr class="tableEvenRow">
                <td><%
                    if ((gadgetRepoServiceClient.isAdmin(loggeduser)) ||
                            (loggeduser.equals(tempCom.getAuthorUserName()))) {
                %>
                    <div class="delete"><a href="javascript:deleteComment(<%=i%>);" title="remove"><img width="16"
                                                                                height="16"
                                                                                src="images/gadget-close.gif"
                                                                                border="0"/></a>
                    </div>
                    <%} %>
                    <strong><%=tempCom.getAuthorUserName()%>,</strong> <%=formatter.format(tempCom.getCreateTime())%>
                    <br/>
                    <%=tempCom.getCommentText()%>
                </td>
            </tr>
            <%}%>

            <%} else {%>
            <tr>
                <td><<STRONG><fmt:message key="no.comments.available"/></STRONG></td>
            </tr>

            <%
                        }
                    }
                }
            %>
        </tbody>


    </thead>
</table>