<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.IGadgetRepoService" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.wso2.carbon.dashboard.common.DashboardConstants" %>
<%@ page import="org.apache.axiom.om.util.Base64" %>
<%
    response.setHeader("Cache-Control","no-cache");
    response.setHeader("Pragma","no-cache");
    response.setDateHeader ("Expires", -1);
    
    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
                    CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    IGadgetRepoService gadgetRepoServiceClient = (IGadgetRepoService) CarbonUIUtil
            .getServerProxy(new GadgetRepoServiceClient(cookie,
                    backendServerURL, configContext, request
                            .getLocale()), IGadgetRepoService.class,
                    session);

    String pageNumStr = request.getParameter("pageNum");
    int pageNum = 0;

    if (pageNumStr != null) {
        try {
            pageNum = Integer.parseInt(pageNumStr);
        } catch (Exception e) {

        }
    }

    int nextGadget = 0;

    if (pageNum != 0) {
        nextGadget = (pageNum * DashboardConstants.GADGETS_PER_PAGE);
    }

    Gadget[] result = gadgetRepoServiceClient.getGadgetDataPag(nextGadget, DashboardConstants.GADGETS_PER_PAGE);
%>
<HEAD>
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="Expires" CONTENT="-1">
</HEAD>
<fmt:bundle basename="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <table class="styledLeft">
        <thead>
        <tr>
            <th><fmt:message key="gadgets"/></th>
        </tr>
        <tbody>
        <tr>
            <td>
                <%
                    if (result != null) {
                        for (int i = 0; i < result.length; i++) {
                            Gadget gadget = result[i];
                            if (gadget != null) {
                %>
                <table width="100%" class="normal gadgetList" id="table-<%=i%>">
                    <tbody>
                    <tr>
                        <td>
                            <%
                                if (gadget.getGadgetScreenBase64() != null
                                        && !gadget.getGadgetScreenBase64().equals(
                                        "")) {
                            %> <img
                                src="image-ajaxprocessor.jsp?imgID=<%=i%>&pg=<%=nextGadget %>&size=<%=DashboardConstants.GADGETS_PER_PAGE %>&random=<%=Math.random()*99999 %>"
                                width="100px"
                                height="100px" class="gadgetImage"/> <%
                        } else {
                        %> <img src="images/no-image.jpg" width="100px" height="100px" class="gadgetImage"/>
                            <%
                                }
                            %>
                        </td>
                        <td width="100%">
                            <p><label><strong><%=gadget.getGadgetName()%>
                            </strong></label><br/>
                                <label><%=gadget.getGadgetUrl()%>
                                </label><br/>
                                <label><%=gadget.getGadgetDesc()%>
                                </label><br/>
                            </p>
                            <input type="hidden" id="gadgetPath-<%=i%>"
                                   value="<%=gadget.getGadgetPath()%>"/></td>
                        <td nowrap="nowrap">
                            <input type="button" id="modifyGadget" class="button" value="<fmt:message key="modify" />"
                                   onclick="modifyGadget(<%=i%>)"/>
                            <input type="button" id="deleteGadget" class="button" value="<fmt:message key="delete" />"
                                   onclick="deleteGadget(<%=i%>)"/>
                            <br/><br/>
                            <input type="checkbox" id="makeDefault-<%=i%>" onclick="makeDefault(<%=i%>)"
                                   <%if("true".equals(gadget.getDefaultGadget())){%>checked="checked"<%} %>><fmt:message
                                    key="make.default"/></input>
                            <br/><br/>
                            <input type="checkbox" id="unsignedUserGadget-<%=i%>"
                                   onclick="makeGadgetForUnsignedUser(<%=i%>)"
                                   <%if("true".equals(gadget.getUnsignedUserGadget())){%>checked="checked"<%} %>><fmt:message
                                    key="make.unsignedUser"/></input>
                        </td>
                    </tr>

                    </tbody>
                </table>
                <%
                            }
                        }

                    }
                %>
            </td>
        </tr>
        </tbody>
        </thead>
    </table>
</fmt:bundle>