<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.IGadgetRepoService" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.apache.axiom.om.util.Base64" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
                    CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    IGadgetRepoService gadgetRepoServiceClient = (IGadgetRepoService) CarbonUIUtil
            .getServerProxy(new GadgetRepoServiceClient(cookie,
                    backendServerURL, configContext, request
                            .getLocale()), IGadgetRepoService.class,
                    session);

    String param = request.getParameter("mode");
    String gadgetPath = request.getParameter("gadgetPath");

    Gadget result = null;
    if ("mod".equals(param)) {
        result = gadgetRepoServiceClient.getGadget(gadgetPath);
    }
%>

<script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript"
        src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"
        src="../yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="javascript/gadgetrepo-server-utils.js"></script>
<script type="text/javascript" src="javascript/gadgetrepo-service-stub.js"></script>

<script type="text/javascript">
    String.prototype.trim = function () {
        return this.replace(/^\s*/, "").replace(/\s*$/, "");
    }

    function init() {
        var onUploadButtonClick = function(e) {


            var gadgetName = document.getElementById('gadgetName').value;
            var gadgetUrl = document.getElementById('gadgetUrl').value;
            var gadgetDesc = document.getElementById('gadgetDesc').value;

            if (hasHTML(gadgetName) || hasHTML(gadgetUrl) || hasHTML(gadgetDesc)) {
                CARBON.showErrorDialog(jsi18n["no.html"]);
            } else if ((gadgetUrl == "") || (gadgetUrl.length == 0) || (gadgetName == "") || (gadgetName.length == 0)) {
                CARBON.showErrorDialog(jsi18n["please.enter.info"]);
            } else if (gadgetUrl.indexOf("https://") == 0) {
                CARBON.showErrorDialog(jsi18n["block.https"]);
            } else {
                //The second argument suggest its a file upload form
                YAHOO.util.Connect.setForm('gadgetForm', true);

                var uploadHandler = {
                    upload: function(o) {

                        if (o.responseText.trim() == "suc") {
                            CARBON.showInfoDialog(jsi18n["gadget.added"]);
                            document.getElementById('gadgetName').value = '';
                            document.getElementById('gadgetUrl').value = '';
                            document.getElementById('gadgetDesc').value = '';
                            document.getElementById('gadgetScreen').value = '';
                        } else if (o.responseText.trim() == "not_image") {
                            CARBON.showErrorDialog(jsi18n["not.image"]);
                        } else if (o.responseText.trim() == "no_data") {
                            CARBON.showErrorDialog(jsi18n["please.enter.info"]);
                        } else if (o.responseText.trim() == "failed") {
                            CARBON.showErrorDialog(jsi18n["duplicated.gadget"]);
                        } else {
                            CARBON.showErrorDialog(jsi18n["unexpected.error"]);
                        }
                    }
                };
                YAHOO.util.Connect.asyncRequest('POST', 'GadgetRepoServiceClient-ajaxprocessor.jsp?mode=add', uploadHandler);
            }
            ;
        }


        var onModifyButtonClick = function(e) {

            var gadgetName = document.getElementById('gadgetName').value;
            var gadgetUrl = document.getElementById('gadgetUrl').value;
            var gadgetDesc = document.getElementById('gadgetDesc').value;

            if (hasHTML(gadgetName) || hasHTML(gadgetUrl) || hasHTML(gadgetDesc)) {
                CARBON.showErrorDialog(jsi18n["no.html"]);
            } else if ((gadgetUrl == "") || (gadgetUrl.length == 0) || (gadgetName == "") || (gadgetName.length == 0)) {
                CARBON.showErrorDialog(jsi18n["please.enter.info"]);
            } else if (gadgetUrl.indexOf("https://") == 0) {
                CARBON.showErrorDialog(jsi18n["block.https"]);
            } else {
                //The second argument suggest its a file upload form
                YAHOO.util.Connect.setForm('gadgetForm', true);

                var uploadHandler = {
                    upload: function(o) {

                        if (o.responseText.trim() == "suc") {
                            window.location = 'index.jsp?region=region1&item=gadgetrepo_menu&name=governance';
                        } else if (o.responseText.trim() == "not_image") {
                            CARBON.showErrorDialog(jsi18n["not.image"]);
                        } else if (o.responseText.trim() == "no_data") {
                            CARBON.showErrorDialog(jsi18n["please.enter.info"]);
                        } else if (o.responseText.trim() == "failed") {
                            CARBON.showErrorDialog(jsi18n["duplicated.gadget"]);
                        } else {
                            CARBON.showErrorDialog(jsi18n["unexpected.error"]);
                        }
                    }
                };
                YAHOO.util.Connect.asyncRequest('POST', 'GadgetRepoServiceClient-ajaxprocessor.jsp?mode=mod&gadgetPath=<%=gadgetPath%>', uploadHandler);
            }
            ;
        }

        YAHOO.util.Event.on('addGadget', 'click', onUploadButtonClick);
        YAHOO.util.Event.on('modifyGadget', 'click', onModifyButtonClick);
    }

    YAHOO.util.Event.on(window, 'load', init);

    function removeImage(pathToImage) {
        GadgetRepoService.deleteGadgetImage(pathToImage);
        $("#imageIco").html('<img id="imageIcon" src="images/no-image.jpg" width="100px" height="100px" class="gadgetImage"/>');
    }

</script>

<fmt:bundle
        basename="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <carbon:breadcrumb label="Add / Modify Gadget"
                       resourceBundle="org.wso2.carbon.policyeditor.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>
    <div id="middle">
        <div id="workArea">
            <%
                if ("add".equals(param)) {
            %>

            <form action="GadgetRepoServiceClient-ajaxprocessor.jsp"
                  enctype="multipart/form-data" method="post" id="gadgetForm">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="new.gadget.info"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td class="formRow">

                            <table class="normal">
                                <tbody>
                                <tr>
                                    <td><label><fmt:message key="gadget.name"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetName"
                                               id="gadgetName"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.url"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetUrl"
                                               id="gadgetUrl"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.description"/></label></td>
                                    <td><textarea rows="5" cols="38" name="gadgetDesc"
                                                  id="gadgetDesc"></textarea></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.sceenshot"/></label></td>
                                    <td><input type="file" size="50" name="gadgetScreen"
                                               id="gadgetScreen"/></td>
                                </tr>

                                </tbody>
                            </table>

                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow"><input type="button"
                                                     value="<fmt:message key="add.gadget.button"/>" class="button"
                                                     id="addGadget"/></td>
                    </tr>
                    </tbody>
                </table>
            </form>
            <%
            } else {
            %>

            <form action="GadgetRepoServiceClient-ajaxprocessor.jsp"
                  enctype="multipart/form-data" method="post" id="gadgetForm">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="modify.gadget.info"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td class="formRow">

                            <table class="normal">
                                <tbody>
                                <tr>
                                    <td><label><fmt:message key="gadget.name"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetName"
                                               id="gadgetName" value="<%=result.getGadgetName()%>"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.url"/></label><span
                                            class="required">&nbsp;* </span></td>
                                    <td><input type="text" size="50" name="gadgetUrl"
                                               id="gadgetUrl" value="<%=result.getGadgetUrl()%>"/></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.description"/></label></td>
                                    <td><textarea rows="5" cols="38" name="gadgetDesc"
                                                  id="gadgetDesc"><%=result.getGadgetDesc()%>
                                    </textarea></td>
                                </tr>

                                <tr>
                                    <td><label><fmt:message key="gadget.sceenshot"/></label></td>
                                    <td><input type="file" size="50" name="gadgetScreen"
                                               id="gadgetScreen"/></td>
                                    <td>
                                        <%
                                            if (result.getGadgetScreenBase64() != null
                                                    && !result.getGadgetScreenBase64()
                                                    .equals("")) {
                                        %>
                                        <div id="imageIco">
                                            <img style="" id="imageIcon"
                                                 src="image-ajaxprocessor.jsp?gadgetPath=<%=gadgetPath%>"
                                                 width="100px" height="100px" class="gadgetImage"/><br/><br/>
                                            <a href="javascript:removeImage('<%=gadgetPath%>')" accesskey=""
                                               id="rmLink">Remove
                                                Image</a>
                                        </div>
                                        <%
                                        } else {
                                        %> <img id="imageIcon" src="images/no-image.jpg" width="100px"
                                                height="100px" class="gadgetImage"/>
                                        <%
                                            }
                                        %>

                                    </td>
                                </tr>

                                </tbody>
                            </table>

                        </td>
                    </tr>
                    <tr>
                        <td class="buttonRow"><input type="button"
                                                     value="<fmt:message key="modify.gadget.button"/>" class="button"
                                                     id="modifyGadget"/></td>
                    </tr>
                    </tbody>
                </table>
            </form>


            <%
                }
            %>
        </div>

    </div>
</fmt:bundle>
