<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.IGadgetRepoService" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="org.wso2.carbon.dashboard.common.DashboardConstants" %>
<%@page import="org.wso2.carbon.dashboard.common.DashboardConstants" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoUiUtils" %>
<%--
 * Copyright 2006-2009 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
--%>

<%
    String activeTab = request.getParameter("tab");
    if (activeTab == null) {
        activeTab = "0";
    }

    String gadgetGrp = request.getParameter("grp");

    String loggeduser = (String) request.getSession().getAttribute("logged-user");

    if ((request.getSession().getAttribute("logged-user") == null)) {
        // We need to log in this user
        response.sendRedirect("../gsusermgt/login.jsp?from=" +
                URLEncoder.encode("../gadgetrepo/gadget-browser.jsp?tab=" + activeTab, "UTF-8"));
        return;
    }

    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
                    CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    IGadgetRepoService gadgetRepoServiceClient = (IGadgetRepoService) CarbonUIUtil
            .getServerProxy(new GadgetRepoServiceClient(cookie,
                    backendServerURL, configContext, request
                            .getLocale()), IGadgetRepoService.class,
                    session);
    String pageNumStr = request.getParameter("pageNum");

    int pages = 0;
    Integer collectionSize = gadgetRepoServiceClient.getCollectionSize();

    if (collectionSize != null) {

        pages = (collectionSize - 1) / DashboardConstants.GADGETS_PER_PAGE;


        if (((collectionSize - 1) % DashboardConstants.GADGETS_PER_PAGE) != 0) {
            pages++;
        }
    }

    // to obtain the portal url with the correct context
    /*String adminConsoleURL = CarbonUIUtil.getAdminConsoleURL(request);
    int index = adminConsoleURL.lastIndexOf("carbon");
    String portalURL = adminConsoleURL.substring(0, index);
    while (portalURL.lastIndexOf("carbon") > 0) {
        portalURL = portalURL.substring(0, portalURL.lastIndexOf("carbon"));
    }
    portalURL = portalURL + "carbon/dashboard/index.jsp";*/

    String portalURL = "../../carbon/dashboard/index.jsp";

%>
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <meta http-equiv="content-type" content="text/html;charset=utf-8"/>
    <title>WSO2 Gadget Server</title>
    <link href="../admin/css/global.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="../admin/css/main.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="../admin/css/gadgets.css" rel="stylesheet" type="text/css"/>
    <link href="style/gadget-browser.css" rel="stylesheet" type="text/css"/>
    <link href="../dialog/css/jqueryui/jqueryui-themeroller.css" rel="stylesheet" type="text/css"
          media="all"/>
    <link href="../dialog/css/dialog.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="../dashboard/localstyles/gadget-server.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="../dashboard/localstyles/gadgets.css" rel="stylesheet" type="text/css"/>
    <link href="../admin/images/favicon.ico" rel="icon" type="image/x-icon"/>
    <link href="../admin/images/favicon.ico" rel="shortcut icon" type="image/x-icon"/>

    <script type="text/javascript" src="../admin/js/jquery.js"></script>
    <script type="text/javascript" src="../admin/js/jquery.form.js"></script>
    <script type="text/javascript" src="../dialog/js/jqueryui/jquery-ui.min.js"></script>
    <script type="text/javascript" src="../admin/js/main.js"></script>
    <script type="text/javascript" src="../admin/js/WSRequest.js"></script>
    <script type="text/javascript" src="../admin/js/cookies.js"></script>

    <script type="text/javascript" src="global-params.js"></script>
    <script type="text/javascript" src="../admin/js/dhtmlHistory.js"></script>
    <script type="text/javascript" src="../admin/js/WSRequest.js"></script>
    <script type="text/javascript" src="../admin/js/breadcrumbs.js"></script>
    <script type="text/javascript" src="../admin/js/cookies.js"></script>

    <script type="text/javascript" src="../yui/build/yahoo/yahoo-min.js"></script>
    <script type="text/javascript" src="javascript/gadgetrepo-server-utils.js"></script>
    <script type="text/javascript" src="javascript/gadgetrepo-service-stub.js"></script>
    <script type="text/javascript" src="javascript/util.js"></script>

    <!--// rating plugin-specific resources //-->
    <script src="javascript/rating/jquery.form.js" type="text/javascript"
            language="javascript"></script>
    <script src="javascript/rating/jquery.MetaData.js" type="text/javascript"
            language="javascript"></script>
    <script src="javascript/rating/jquery.rating.js" type="text/javascript"
            language="javascript"></script>
    <link href="javascript/rating/jquery.rating.css" type="text/css" rel="stylesheet"/>

    <script type="text/javascript" src="../dialog/js/dialog.js"></script>

    <script type="text/javascript">
        var userId = '<%=loggeduser%>';
        <%if(pageNumStr == null){%>
        $(document).ready(function() {
            // load home page when the page loads
            $("#repo-browser").load("items-ajaxprocessor.jsp?grp=<%=gadgetGrp%>&tab=<%=activeTab%>&pageNum=" + 0);
        });
        <%}%>

        function addGadgetToDashboard(id) {
            var elementId = "gadgetUrlFromRepo-" + id;
            var gadgetUrl = document.getElementById(elementId).value;

            var pathElementId = "gadgetPath-" + id;
            var gadgetPath = document.getElementById(pathElementId).value;

            if ((gadgetUrl == "") || (gadgetUrl.length == 0)) {
                CARBON.showErrorDialog(jsi18n["please.enter.location"]);
            } else if (gadgetUrl.indexOf("https://") == 0) {
                CARBON.showErrorDialog(jsi18n["block.https"]);
            } else {
                GadgetRepoService.addGadget(userId, <%=activeTab%>, gadgetUrl, null, gadgetPath, '<%=gadgetGrp%>#');
                window.location = '<%=portalURL%>?tab=<%=activeTab%>';
            }
        }

        function addGadget() {
            var gadgetUrl = document.getElementById('gadgetUrl').value;

            if ((gadgetUrl == "") || (gadgetUrl.length == 0)) {
                CARBON.showErrorDialog(jsi18n["please.enter.location"]);
            } else if (gadgetUrl.indexOf("https://") == 0) {
                CARBON.showErrorDialog(jsi18n["block.https"]);
            } else {
                GadgetRepoService.addGadget(userId, <%=activeTab%>, gadgetUrl, null, null, '<%=gadgetGrp%>#');
                window.location = '<%=portalURL%>?tab=<%=activeTab%>';
            }
        }


        function returnToDashboard() {
            window.location = '<%=portalURL%>?tab=<%=activeTab%>';
        }

        function paginate(num) {
            $(document).ready(function() {
                // load home page when the page loads
                $("#repo-browser").load("items-ajaxprocessor.jsp?grp=<%=gadgetGrp%>&pageNum=" + num);
            });
        }
    </script>

</head>

<body>
<div id="dcontainer"></div>
<div id="link-panel">
    <div class="right-links">
        <ul>
            <li><strong>Signed-in as&nbsp;<%=loggeduser%>
            </strong></li>
            <li>|</li>
            <li>
                <a href="javaScript:redirectToHttpsUrl('../admin/logout_action.jsp?IndexPageURL=/carbon/gsusermgt/middle.jsp', '<%=GadgetRepoUiUtils.getHttpsPort(backendServerURL)%>')">Sign-out</a>
            </li>
        </ul>
    </div>
    <div class="left-logo"><a class="header-home" href="<%=portalURL%>">
        <img width="179" height="28" src="images/1px.gif"/> </a></div>
</div>

<fmt:bundle basename="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <div id="middle">
        <div id="workArea">

            <table width="100%" height="100%" cellspacing="0">
                <tr>
                    <td>
                        <ul class="gadgets-top-links">
                            <li><a class="icon-link"
                                   style="background-image: url(images/dashboard.gif);"
                                   onclick="returnToDashboard()"><fmt:message
                                    key="return.to.dashboard"/></a></li>
                        </ul>
                    </td>
                </tr>

                <%
                    if (gadgetRepoServiceClient.isExternalGadgetAdditionEnabled()) {
                %>
                <tr>
                    <td>
                        <table class="styledLeft">
                            <thead>
                            <tr>
                                <th><fmt:message key="enter.gadget.location"/></th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr>
                                <td class="formRow">
                                    <table class="normal">
                                        <tbody>
                                        <tr>
                                            <td>
                                                <label><fmt:message key="enter.url"/></label>
                                            </td>
                                            <td>
                                                <input type="text" size="50" name="gadgetUrl"
                                                       id="gadgetUrl"/>
                                            </td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="buttonRow">
                                    <input type="button" onclick="addGadget()"
                                           value="<fmt:message key="add.gadget.button"/>"
                                           class="button" id="addGadget"/>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </td>
                </tr>
                <%
                    }
                %>
                <tr>
                    <td>
                        <div class="pagination"><% if (pages > 1) {
                            for (int i = 0; i < pages; i++) {
                                out.print("<a href=\"javascript:paginate(" + (i) + ");\" class=\"pageLinks\" >" + (i + 1) + "</a>&nbsp;");
                            }
                        } %></div>
                    </td>
                </tr>
                <tr>
                    <td height="100%" style="background-color: #FFFFFF;">
                        <div id="repo-browser"><!-- Loads data useing ajax (items-ajaxprocessor.jsp) --></div>
                    </td>
                </tr>
                <tr>
                    <td style="background-color: #FFFFFF; padding-bottom: 5px;">
                        <div class="pagination"><% if (pages > 1) {
                            for (int i = 0; i < pages; i++) {
                                out.print("<a href=\"javascript:paginate(" + (i) + ");\" class=\"pageLinks\" >" + (i + 1) + "</a>&nbsp;");
                            }
                        } %></div>
                    </td>
                </tr>
                <tr>
                    <td height="20">
                        <div class="footer-content">
                            <div class="copyright">&copy; 2008 - 2010 WSO2 Inc. All Rights Reserved.</div>
                        </div>
                    </td>
                </tr>
                </tbody>
                </thead>
            </table>
        </div>

    </div>
    </body>
    </html>
</fmt:bundle>