<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.IGadgetRepoService" %>
<%@ page
        import="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.GadgetRepoServiceClient" %>
<%@ page import="org.wso2.carbon.dashboard.mgt.gadgetrepo.common.Gadget" %>
<%@ page import="org.wso2.carbon.dashboard.common.DashboardConstants" %>
<%@ page import="org.apache.axiom.om.util.Base64" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config
            .getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config
            .getServletContext().getAttribute(
                    CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session
            .getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    IGadgetRepoService gadgetRepoServiceClient = null;

    String pageNumStr = null;
    int pages = 0;

    try {
        gadgetRepoServiceClient = (IGadgetRepoService) CarbonUIUtil
                .getServerProxy(new GadgetRepoServiceClient(cookie,
                        backendServerURL, configContext, request
                                .getLocale()), IGadgetRepoService.class,
                        session);

        pageNumStr = request.getParameter("pageNum");
        pages = 0;
        if (gadgetRepoServiceClient.getCollectionSize() != null) {
            pages = (gadgetRepoServiceClient.getCollectionSize() - 1) / DashboardConstants.GADGETS_PER_PAGE;


            if (((gadgetRepoServiceClient.getCollectionSize() - 1) % DashboardConstants.GADGETS_PER_PAGE) != 0) {
                pages++;
            }
        }
    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }

%>
<script type="text/javascript" src="javascript/jquery-latest.js"></script>
<script type="text/javascript"
        src="javascript/gadgetrepo-service-stub.js"></script>
<script type="text/javascript"
        src="javascript/gadgetrepo-server-utils.js"></script>

<script type="text/javascript">
    <%if(pageNumStr == null){%>
    $(window).load(function() {

        // load home page when the page loads
        $("#gadget-table").load("GadgetRepoItems-ajaxprocessor.jsp?pageNum=" + 0 + "&random=<%=Math.random()*99999 %>");
    });
    <%}%>

    function deleteGadget(gadgetId) {
        var gadgetPath = document.getElementById('gadgetPath-' + gadgetId).value;
        GadgetRepoService.deleteGadget(gadgetPath);
        $('#table-' + gadgetId).fadeOut('slow');
    }

    function modifyGadget(gadgetId) {
        var gadgetPath = document.getElementById('gadgetPath-' + gadgetId).value;
        location.href = 'add-gadget.jsp?mode=mod&gadgetPath=' + gadgetPath;

    }

    function paginate(rand, num) {
       // $(document).ready(function() {
            // load home page when the page loads
            $("#gadget-table").load("GadgetRepoItems-ajaxprocessor.jsp?pageNum=" + num + "&random=" + rand );
       // });
    }

    function makeDefault(gadgetId) {
        var isChecked = document.getElementById('makeDefault-' + gadgetId).checked;
        var gadgetPath = document.getElementById('gadgetPath-' + gadgetId).value;
        GadgetRepoService.makeDefault(gadgetPath, isChecked);

    }

    function makeGadgetForUnsignedUser(gadgetId) {
        var isChecked = document.getElementById('unsignedUserGadget-' + gadgetId).checked;
        var gadgetPath = document.getElementById('gadgetPath-' + gadgetId).value;
        GadgetRepoService.unsignedUserGadget(gadgetPath, isChecked);

    }

</script>

<link rel="stylesheet" type="text/css" href="../admin/css/main.css"/>
<fmt:bundle
        basename="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.mgt.gadgetrepo.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <carbon:breadcrumb label="view"
                       resourceBundle="org.wso2.carbon.policyeditor.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>
    <div id="middle">
        <h2><fmt:message key="gadget.repository"/></h2>

        <div id="workArea">
            <table width="100%">
                <tr>
                    <td>
                        <ul class="gadgets-top-links">
                            <li><a class="icon-link"
                                   style="background-image: url(../admin/images/add.gif);"
                                   href="add-gadget.jsp?mode=add"><fmt:message
                                    key="add.new.gadget"/></a></li>
                        </ul>
                    </td>
                </tr>
                <tr>
                    <td>
                        <div class="pagination"><% if (pages > 1) {
                            for (int i = 0; i < pages; i++) {
                                out.print("<a href=\"javascript:paginate(" + (Math.random() * 9999) + "," + (i) + ");\" class=\"pageLinks\" >" + (i + 1) + "</a>&nbsp;");
                            }
                        } %></div>
                    </td>
                </tr>
            </table>

            <div id="gadget-table"><!-- takes from GadgetRepoItems-ajaxprocessor.jsp --></div>

            <table style="float: right;">
                <tr>
                    <td>
                        <div class="pagination"><% if (pages > 1) {
                            for (int i = 0; i < pages; i++) {
                                out.print("<a href=\"javascript:paginate("+ (Math.random() * 99999) + "," + (i) + ");\" class=\"pageLinks\" >" + (i + 1) + "</a>&nbsp;");
                            }
                        } %></div>
                    </td>
                </tr>
            </table>
        </div>
    </div>
</fmt:bundle>